#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    vector<int> niz(n);
    vector<int> nule;
    bool jeste=true;
    for(int i=0;i<n;i++){
        cin>>niz[i];
        if(niz[i]==0){
            nule.push_back(i+1);
        }
        if(niz[i]!=1 && niz[i]!=0) jeste=false;
    }
    while(q--){
        int l,r;
        cin>>l>>r;
        if(jeste){
            if(nule.size()==0){
                cout<<1;
                continue;
            }
            int prva=*lower_bound(nule.begin(),nule.end(),l);
            int druga=*(upper_bound(nule.begin(),nule.end(),r)-1);
        //    cout<<prva<<" "<<druga<<" ";
            if(prva>r && druga<l){
                cout<<1<<endl;
            }else{
                cout<<0<<endl;
            }
        }else{
            int rez=niz[l-1];
            for(int i=l;i<r;i++){
       //         cout<<rez<<endl;
                rez&=niz[i];
            }
            cout<<rez<<endl;
        }
    }
    return 0;
}